#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DarkGray
#property indicator_color2 DarkGray

extern int ChannelPeriod = 21;
double g_ibuf_80[];
double g_ibuf_84[];

int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_80);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, g_ibuf_84);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   string ls_0 = "Donchian Channel(" + ChannelPeriod + ")";
   IndicatorShortName(ls_0);
   int l_ind_counted_8 = IndicatorCounted();
   int l_index_12 = 0;
   int li_16 = Bars - l_ind_counted_8;
   while (l_index_12 <= li_16) {
      g_ibuf_80[l_index_12] = High[iHighest(NULL, 0, MODE_HIGH, ChannelPeriod, l_index_12 + 1)];
      g_ibuf_84[l_index_12] = Low[iLowest(NULL, 0, MODE_LOW, ChannelPeriod, l_index_12 + 1)];
      l_index_12++;
   }
   return (0);
}
